//
//  count.js
//  Library
//
//  Created by Jonathon Mah on 2013-03-18.
//  Copyright (c) 2013 Delicious Monster Software. All rights reserved.
//


function Count(chartDiv, svg, width, height) {
    this.chartDiv = chartDiv;
    chartDiv.classed("count", true);
    this.svg = svg;
    this.width = width;
    this.height = height;

    this.initialValue = 0;
    this.dataFunction = function() { return 0; };

    this.formatsByWidth = [ // widest to narrowest
        d3.format(",.0f"),
        d3.format(",.3s"),
        d3.format(",.2s"),
    ];

    this.text =
        this.svg
        .append("text")
        .attr("text-anchor", "end")
        .attr("x", width)
        .attr("y", 26); // magic number so it abuts the top
}


Count.prototype.update = function() {
    var self = this;
    var total = this.dataFunction();

    // update
    this.text
        .datum(total)
        .transition()
        .duration(750)
        .ease(d3.ease("cubic-out"))
        .tween("text", function(d) {
            if (typeof this._current === "undefined")
                this._current = self.initialValue;

            var i = d3.interpolate(this._current, d);
            this._current = d;
            return function(t) {
                var v = i(t);
                // Try formats until one fits in our space (or we run out)
                for (var j = 0; j < self.formatsByWidth.length; j++) {
                    this.textContent = self.formatsByWidth[j](v);
                    if (this.getBBox().width <= self.width)
                        break;
                }
            };
        });
};
